﻿using MVCSampleBrowser.Models;
using Syncfusion.JavaScript;
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;

using System.Web.Mvc;
using System.Collections;
using Syncfusion.Linq;
using System.Web.Script.Serialization;
using Syncfusion.JavaScript.Models;
using Syncfusion.EJ.Export;
using System.Reflection;
using Syncfusion.XlsIO;
using System.Reflection.Emit;
using System.Threading;
using Syncfusion.Pdf.Graphics;

namespace MvcApplication66.Controllers
{
    public class HomeController : Controller
    {
        public int id { get; set; }
        public ActionResult Index()
        {
            List<Person> Persons = new List<Person>();
            Persons.Add(new Person() { FirstName = "阿斯蒂芬", LastName = "Beckett" });
            Persons.Add(new Person() { FirstName = "Ben", LastName = "Beckett"});
            Persons.Add(new Person() { FirstName = "阿斯蒂芬", LastName = "阿斯蒂芬" });
            ViewBag.datasource = Persons;
            return View();
        }
        [Serializable]
        public class Person
        {
            public Person()
            {

            }
            public Person(string FirstName, string LastName)
            {
                this.FirstName = FirstName;
                this.LastName = LastName;

            }
            public string FirstName { get; set; }
            public string LastName { get; set; }

        }
       
        public void ExportToPdf(string GridModel)
        {
            PdfExport exp = new PdfExport();
            List<Person> Persons = new List<Person>();
            Persons.Add(new Person() { FirstName = "阿斯蒂芬", LastName = "Beckett" });
            Persons.Add(new Person() { FirstName = "Ben", LastName = "Beckett" });
            Persons.Add(new Person() { FirstName = "阿斯蒂芬", LastName = "阿斯蒂芬" });
            GridProperties obj = ConvertGridObject(GridModel);
            var DataSource = Persons;
            //GridProperties prop = (GridProperties)DeserializeToModel(typeof(GridProperties), GridModel);
            obj.ServerPdfQueryCellInfo = QueryCellInfo;
            exp.Export(obj, DataSource, "Export.pdf", false, false,true, "flat-saffron");
        }
        public void QueryCellInfo(object currentCell)
        {
            Syncfusion.Pdf.Grid.PdfGridCell range = (Syncfusion.Pdf.Grid.PdfGridCell)currentCell;
            range.Style.Font = new PdfTrueTypeFont(new System.Drawing.Font("Arial Unicode MS", 12f), true);
        } 
        public class Orderdetail : OrdersView
        {
            public string LastName { get; set; }
        }
        private GridProperties ConvertGridObject(string gridProperty)
        {
            JavaScriptSerializer serializer = new JavaScriptSerializer();
            IEnumerable div = (IEnumerable)serializer.Deserialize(gridProperty, typeof(IEnumerable));
            GridProperties gridProp = new GridProperties();
            foreach (KeyValuePair<string, object> ds in div)
            {
                  var property = gridProp.GetType().GetProperty(ds.Key, BindingFlags.Instance | BindingFlags.Public | BindingFlags.IgnoreCase);
                    if (property != null)
                    {
                        Type type = property.PropertyType;
                        string serialize = serializer.Serialize(ds.Value);
                        object value = serializer.Deserialize(serialize, type);
                        property.SetValue(gridProp, value, null);
                    }
            }
            return gridProp;
        }

    }

}
